package com.ff.weijinxiao.service;


import com.ff.weijinxiao.domain.GoodsCategory;
import com.ff.weijinxiao.repository.GoodsCategoryRepository;
import com.ff.weijinxiao.util.SpecificationUtil;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;
import java.util.Optional;

@Service
public class GoodsCategoryService {

    @Resource
    private GoodsCategoryRepository goodsCategoryRepository;

    /**
     * 创建实体
     *
     * @param goodsCategory
     */
    public GoodsCategory saveGoodsCategory(GoodsCategory goodsCategory) {
        return goodsCategoryRepository.save(goodsCategory);
    }

    /**
     * 查找实体
     *
     * @param id
     * @return
     */
    public GoodsCategory findById(Integer id) {
        Optional<GoodsCategory> optional = goodsCategoryRepository.findById(id);
        if (optional.isPresent()) {
            return optional.get();
        } else {
            return null;
        }
    }

    public GoodsCategory findByOnlyID(String onlyID) {
        return goodsCategoryRepository.findByOnlyID(onlyID);
    }

    public void deleteById(Integer id) {
        goodsCategoryRepository.deleteById(id);
    }

    /**
     * 分页条件查询
     *
     * @param page
     * @param size
     * @param param
     * @return
     */
    public Page<GoodsCategory> findPage(int page, int size, Map<String, Object> param) {
        Sort.Direction direction = Sort.Direction.DESC;
        String sort = "id";
        Pageable pageable = new PageRequest(page - 1, size, direction, sort);
        return goodsCategoryRepository.findAll(SpecificationUtil.buildSpecification(param, GoodsCategory.class), pageable);
    }

    /**
     * 根据条件查询List
     */
    public List<GoodsCategory> findList(Map<String, Object> param) {
        return goodsCategoryRepository.findAll(SpecificationUtil.buildSpecification(param, GoodsCategory.class));
    }

}
